unit MainForm2clx;
{Analyzed by:           PAL - Pascal Analyzer version 2.1.9.1
Parse speed:            186 lines in 0.11 seconds (1691 lines/sec).
Main file:              D:\FRANKTECH\DELPHMAX\HEXER\MAINFORM2.PAS
Compilers:              Delphi 7.1, ModelMaker 6.2
                        Kylix2, CLX, clib, locs = 212}

interface

uses
  QForms, QDialogs,
  QStdCtrls, QControls, QExtCtrls, Classes;

type
  TForm1 = class(TForm)
    btnConvert: TButton;
    lbFilesToConvert: TListBox;
    btnAddFiles: TButton;
    btnDeleteFiles: TButton;
    edtUnitToCreate: TEdit;
    btnBrowse: TButton;
    Bevel1: TBevel;
    lblfiles: TLabel;
    lblunit: TLabel;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    btnExit: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnAddFilesClick(Sender: TObject);
    procedure btnBrowseClick(Sender: TObject);
    procedure lbFilesToConvertClick(Sender: TObject);
    procedure btnDeleteFilesClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure btnConvertClick(Sender: TObject);
  private
    { Private declarations }
    procedure CheckButtonStatus;
    procedure ConvertToUnit;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses sysutils;

const
  CRLF = #13#10;
  CRLF2 = #13#10#13#10;
  STR3L = '   ';

procedure TForm1.CheckButtonStatus;
begin
  btnConvert.Enabled:= (edtUnitToCreate.Text <> '') and
                        (lbFilesToConvert.Items.Count > 0);
  btnDeleteFiles.Enabled:= lbFilesToConvert.SelCount > 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CheckButtonStatus;
end;

procedure TForm1.btnAddFilesClick(Sender: TObject);
var x : integer;
begin
  if OpenDialog.Execute then
    if OpenDialog.Files.Count > 0 then
      for x:= 0 to OpenDialog.Files.Count-1 do
        if not lbFilesToConvert.Items.IndexOf(OpenDialog.Files[x]) > -1 then
          lbFilesToConvert.Items.Add(OpenDialog.Files[x]);
    CheckButtonStatus;
end;

procedure TForm1.btnBrowseClick(Sender: TObject);
begin
  if SaveDialog.Execute then
    edtUnitToCreate.Text:= SaveDialog.FileName;
  CheckButtonStatus;
end;

procedure TForm1.lbFilesToConvertClick(Sender: TObject);
begin
  CheckButtonStatus;
end;

procedure TForm1.btnDeleteFilesClick(Sender: TObject);
begin
  //lbFilesToConvert.DeleteSelected;
  CheckButtonStatus;
end;

procedure TForm1.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.btnConvertClick(Sender: TObject);
begin
  //procedure could be moved to a logic unit
  ConvertToUnit;
end;

procedure TForm1.ConvertToUnit;
var f_hndoutput: THandle;
    cntr: integer;
    f_error: boolean;
const blocksize = 19;

  function WriteString(const theString: string) : boolean;
  var bytesToWrite,
      bytesWritten: cardinal;
  begin
    bytesToWrite:= Length(theString);
    //_write(DF, theString[1], length(theString));
    //win WriteFile(f_hndoutput, theString[1], bytesToWrite, bytesWritten, NIL);
    {FileWrite writes Count bytes to the file given by Handle from the buffer
    specified by Buffer. Handle is a file handle returned
    by the FileOpen or FileCreate method.}
    bytesWritten:= fileWrite(f_hndoutput, theString[1], length(theString));
    Result:= bytesToWrite = bytesWritten;
  end;

  function EmbedFile(const filename: string): boolean;
  var f_hndopen: THandle;
      abuf: array[0..blocksize] of byte;
      fibyte: file of byte;
      bytesRead, x,
      fSizeHigh, fSizeLow: cardinal;
      fSize: longint;
      fExtension: string;
  begin
    //win f_hndopen:= CreateFile(PChar(filename),  GENERIC_WRITE + GENERIC_READ,
    //          0, NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
    // test writes the exe
    f_hndopen:= FileOpen(pchar(filename), fmOpenRead);
    Result:= f_hndopen <> -1;
    {If the file is declared as a file of byte, then the record size defaults
    to one byte, and FileSize returns the number of bytes in the file.}
    if Result then begin
      assignfile(fibyte, filename);
      reset(fibyte);
      fSize:= fileSize(fibyte);
      closeFile(fibyte);
      //win fSizeLow:= GetFileSize(f_hndopen, @fSizeHigh);
      //Result:= (fSizeLow <> $ffffffff) or (GetLastError = NO_ERROR);
      //if Result then begin
      //fSize:= int64(fSizeHigh) * $100000000 + fSizeLow;
        fExtension:= ExtractFileExt(filename);
        if Length(fExtension) > 0 then
          Delete(fExtension,1,1);
        Result:= WriteString(STR3L +
                  ExtractFileName(ChangeFileExt(filename,'_'+fExtension)) +
                  ': array[0..' + IntToStr(fSize-1) + '] of byte = (' + CRLF);
        if Result then begin
          repeat
            //win bytesToRead:= sizeof(buffer);
            //Result:= ReadFile(f_hndopen, abuf, sizeof(abuf), bytesRead, NIL);
            bytesRead:= FileRead(f_hndopen, abuf, sizeof(abuf));
            if bytesRead > 0 then begin
              Result:= Result and WriteString(STR3L);
              for x:= 0 to bytesRead-1 do begin
                if x > 0 then
                   Result:= Result and WriteString(',');
                Result:= Result and WriteString('$'+IntToHex(abuf[x], 2));
              end;
              fSize:= fSize - bytesRead;
              if fSize > 0 then
                Result:= Result and WriteString(',' + CRLF);
            end;
          until (bytesRead = 0) or not Result;
          Result:= Result and WriteString(');' + CRLF2);
        end;
      //end;
      FileClose(f_hndopen);
      //CloseHandle(f_hndopen);

    end; //result
  end;
begin
  //win f_hndoutput:= CreateFile(PChar(ChangeFileExt(edtUnitToCreate.Text, '.pas')),
  //               GENERIC_WRITE, 0, NIL,
  //               CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
  f_hndoutput:= FileCreate(pchar(ChangefileExt(edtUnitToCreate.Text, '.pas')));

  f_error:= false;
  if f_hndoutput <> -1 then begin
    Screen.Cursor:= crHourGlass;
    if WriteString('Unit ' + ExtractFileName(ChangeFileExt(edtUnitToCreate.Text,
                        '')) + ';' + CRLF) then begin
      if WriteString(CRLF + 'interface' + CRLF2) then
        if WriteString('const ' + CRLF) then begin
          for cntr:= 0 to lbFilesToConvert.Items.Count-1 do
             if EmbedFile(lbFilesToConvert.Items[cntr]) then
          if WriteString(CRLF + 'implementation' + CRLF2) then
             f_error:= not WriteString('end.');
        end;
    end;
    Screen.Cursor:= crDefault;
    //CloseHandle(f_hndoutput);
    FileClose(f_hndoutput);
  end;
  // in normal case notrue !
  if f_error then
    ShowMessage('Some Errors occured');
end;

end.

